﻿using System;
using System.Collections.Generic;
using System.Text;
using Cmq_SDK.Cmq;
using Cmq_SDK.Exception;
namespace Demo
{
    class Program
    {
        static void Main(string[] args)
        {
            string secretId = "";
            string secretKey = "";
            string endpoint = "http://cmq-queue-gz.api.qcloud.com";
            try
            {
                CmqAccount account = new CmqAccount(endpoint, secretId, secretKey);
                QueueMeta meta = new QueueMeta();
                string queueName = "dotNet-create-test";
                account.createQueue(queueName, meta);

                List<string> queueList = new List<string>();
                int totalCount = account.listQueue(queueName, 0, 0, queueList);
                if (!queueList.Contains(queueName))
                    Console.Write("create Fail");
                else
                    Console.Write("create queue :" + queueName + "success\n");
                //set queue Attributes
                Queue queue = account.getQueue(queueName);
                int maxMsgHeapNum = 5000000;
                meta.maxMsgHeapNum = maxMsgHeapNum;
                queue.setQueueAttributes(meta);
                Console.Write("set queue maxMsgHeapNum to 5000000\n");
                //get queue Attributes
                QueueMeta queueAttributes = queue.getQueueAttributes();
                Console.Write("get queue maxMsgHeapNum: " + Convert.ToString(queueAttributes.maxMsgHeapNum) + Environment.NewLine);

                //send message
                string msgbody = "test send message ";
                string msgId = queue.sendMessage(msgbody, 0);
                Console.Write("send message to queue sucess, msgId = " + Convert.ToString(msgId) + Environment.NewLine);

                //receive message
                Message msg = queue.receiveMessage(10);
                Console.Write("receive message from queue: " + msg.msgBody + Environment.NewLine);

                //delete message
                queue.deleteMessage(msg.receiptHandle);
                Console.Write("delete message from queue" + Environment.NewLine);

                //batch send message
                List<string> vtMsgBody = new List<string> {
                    "batch send test1",
                    "batch send test2"
                };
                List<string> vtMsgIds = queue.batchSendMessage(vtMsgBody, 0);
                Console.Write("batch send message sucess, msgids: " + Environment.NewLine);
                foreach (var item in vtMsgIds) {
                    Console.Write(item + Environment.NewLine);
                }

                //batch receive message
                List<Message> vtMsg = queue.batchReceiveMessage(vtMsgBody.Count, 0);
                Console.Write("batch receive messages sucess, message body: " + Environment.NewLine);
                foreach (var item in vtMsg) {
                    Console.WriteLine(item.msgBody);
                }

                //batch delete message
                List<string> vtReceiptHandle = new List<string>();
                foreach (var item in vtMsg) {
                    vtReceiptHandle.Add(item.receiptHandle);
                }
                queue.batchDeleteMessage(vtReceiptHandle);
                Console.WriteLine("batch delete message success");


                account.deleteQueue(queueName);
                queueList.Clear();
                totalCount = account.listQueue(queueName, 0, 0, queueList);
                if (queueList.Contains(queueName))
                    Console.Write("delete fail");
                else
                    Console.Write("delete queue success" + Environment.NewLine);
            }
            catch (ClientException e)
            {
                Console.Write(e.Message);
            }
            catch (ServerException e)
            {
                Console.Write(e.ToString());
            }
            catch (Exception e) {
                Console.Write(e.Message);
            }

            return;
        }
    }
}
