using System;
using System.Collections.Generic;
using System.Text;
using Cmq_SDK.Cmq;
using Cmq_SDK.Exception;
namespace Demo
{
    class Program
    {
        static void Main(string[] args)
        {
            string secretId = "";
            string secretKey = "";
            string endpoint = "http://cmq-topic-gz.api.qcloud.com";
            try
            {

                CmqAccount account = new CmqAccount(endpoint, secretId, secretKey);
                string topicName = "dotNet-test";
                string subscriptionName = "subsc-test";
                account.createTopic(topicName, 65536);
                Console.WriteLine("create topic success");

                List<string> topicList = new List<string>();
                int totalCount = account.listTopic(topicName, 0, 0, topicList);
                Console.WriteLine("list topic success");
                for (int i = 0; i < topicList.Count; ++i)
                    Console.WriteLine("topicName:" + topicList[i]);

                //get topic Attributes
                Topic topic = account.getTopic(topicName);
                TopicMeta meta = new TopicMeta();
                meta = topic.getTopicAttributes();
                Console.WriteLine("msg count:" + Convert.ToString(meta.msgCount));
                Console.WriteLine("max msg size:" + Convert.ToString(meta.maxMsgSize));
                Console.WriteLine("msg retention second:" + Convert.ToString(meta.msgRetentionSeconds));
                Console.WriteLine("create time:" + Convert.ToString(meta.createTime));
                Console.WriteLine("last modify time:" + Convert.ToString(meta.lastModifyTime));
                Console.WriteLine("filter Type:" + Convert.ToString(meta.filterType));

                topic.setTopicAttributes(32768);
                Console.WriteLine("msg count:" + Convert.ToString(meta.msgCount));
                Console.WriteLine("max msg size:" + Convert.ToString(meta.maxMsgSize));
                Console.WriteLine("msg retention second:" + Convert.ToString(meta.msgRetentionSeconds));
                Console.WriteLine("create time:" + Convert.ToString(meta.createTime));
                Console.WriteLine("last modify time:" + Convert.ToString(meta.lastModifyTime));
                Console.WriteLine("filter Type:" + Convert.ToString(meta.filterType));


                string subscEndpoint = "http://test.hahaha.com";
                string protocal = "http";

                account.createSubscribe(topicName, subscriptionName,subscEndpoint, protocal);
                Console.WriteLine("create subscription ");
                Subscription subsc = account.getSubscribe(topicName, subscriptionName);

                List<string> subscriptionList = new List<string>();
                topic.ListSubscription(0, 0, "", subscriptionList);
                for (int i = 0; i < subscriptionList.Count; ++i)
                    Console.WriteLine("subscripton Name:" + subscriptionList[i]);

                string msg = "this is a test message";
                topic.publishMessage(msg);
                Console.WriteLine("publish message:" + msg);
                List<string> vMsg = new List<string>();
                int msgCount = 5;
                for (int i = 0; i < msgCount; ++i)
                    vMsg.Add(msg);
                topic.batchPublishMessage(vMsg);
                Console.WriteLine("batch publish message success");

                account.deleteSubscribe(topicName, subscriptionName);
                account.deleteTopic(topicName);
                Console.WriteLine("delete subsc success");
                Console.WriteLine("delete topic success");
                Console.Read();

            }
            catch (ClientException e)
            {
                Console.Write(e.Message);
            }
            catch (ServerException e)
            {
                Console.Write(e.ToString());
            }
            catch (Exception e) {
                Console.Write(e.Message);
            }

            return;
        }
    }
}
